package net.lenkaspace.robotForaging.model;

import net.lenkaspace.creeper.model.CRBaseDynamicModel;
import net.lenkaspace.creeper.model.CRBaseSituatedModel;
import net.lenkaspace.creeper.model.CRParameters;
import net.lenkaspace.creeper.report.CRReportController;
import net.lenkaspace.creeper.report.CRTimeSeriesReport;
import net.lenkaspace.creeper.view.CRRenderer;
import net.lenkaspace.creeper.vo.CRVector3d;

public class Base extends CRBaseDynamicModel {

	public double totalResource;
	private double totalRecruitedResource;
	
	public Base(CRVector3d position_) {
		super(10000, position_, new CRVector3d(100,100,0), 0, CRBaseSituatedModel.SHAPE.CIRCLE, CRRenderer.CR_GREEN_CIRCLE);
		totalResource = 0;
		totalRecruitedResource = 0;
	}
	
	public void update() {
		super.update();
		CRReportController reportController = world.getController().getReportController();
		Parameters parameters = Parameters.getSingleton();
		CRTimeSeriesReport report = ((CRTimeSeriesReport)reportController.getReport(Settings.REPORT_RESOURCE_COLLECTED));
		report.addValue(totalResource / parameters.totalResourceAvailable, Settings.VAR_TOTAL_RESOURCE); 
		report.addValue(totalRecruitedResource /  parameters.totalResourceAvailable, Settings.VAR_RECRUITERD_RESOURCE);
	}
	
	public void addResource(double amount_, double resourceRecruiterId_) {
		totalResource += amount_;
		if (resourceRecruiterId_ >= 0) {
			totalRecruitedResource += amount_;
		}
	}
}
